@echo off

rem arc-asm-list.bat for Arduino/Genuino 101 
rem This file is licensed under BSD license.
rem by audin 2016/02

set dir_gcc_bin=%UserProfile%\AppData\Local\Arduino15\packages\Intel\tools\arc-elf32\1.6.4+1.0/bin
set tool_prefix=arc-elf32
set objdump=%tool_prefix%-objdump
set size=%tool_prefix%-size
set target_dir=build
echo ------ [ARC Processer] ------
echo;
echo [t@C]
rem ---------------------
rem *.elft@C擾(΃pX+t@C+gq)
rem ---------------------
for %%i in (%target_dir%\*.elf) do set f_elf="%%i"
echo ELF file name = %f_elf% 

rem ---------------------
rem XPb`t@C𐶐
rem ---------------------
call :getScketchName %f_elf%
call :getScketchName %sketch_name%
echo Scketch  name = %sketch_name%.ino

rem ---------------------
rem *.lstt@C𐶐
rem ---------------------
set f_list=%sketch_name%.ino.lst
echo List file name= %f_list%
rem ---------------------
rem NIuWFNgXg̐
rem ---------------------
set objs=z_objs.txt
set ferr=z_err.txt
if exist %objs% del %objs%
set /p<nul=%objs%
echo;
for /f %%i in ('dir /b /s build\sketch\*.o') do (
	if not %%i=="" set /p<nul="%%i "   >> %objs%
)
rem tH_ۂǂ̃`FbN
dir /b /s build\libraries\*.o 2> %ferr%
for %%I in ( %ferr% ) do set esize=%%~zI
if %esize% neq 0 goto jmp1   
rem tH_*.o鎞C
for /f %%i in ('dir /b /s build\libraries\*.o') do (
	if not %%i=="" set /p<nul="%%i "   >> %objs%
)
:jmp1
set /p<nul="build\core\variant.cpp.o " >> %objs%
set /p<nul="build\core\core.a"         >> %objs%

rem ---------------------
rem *.elft@CV{tōĐ
rem ---------------------
echo;
echo [IuWFNgt@C̍ăN...]
set    temp1=z_cmd.txt
set relinker=z_link.bat

set /p<nul=""%UserProfile%\AppData\Local\Arduino15\packages\Intel\tools\arc-elf32\1.6.4+1.0/bin/arc-elf32-gcc" -nostartfiles -nodefaultlibs -nostdlib -static -Wl,-X -Wl,-N -Wl,-mARCv2EM -Wl,-marcelf -Wl,--gc-sections "-T%UserProfile%\AppData\Local\Arduino15\packages\Intel\hardware\arc32\1.0.4\variants\arduino_101/linker_scripts/flash.ld" "-Wl,-Map,build/%sketch_name%.ino.map" -o "build/%sketch_name%.ino.elf" "-Lbuild" "-L%UserProfile%\AppData\Local\Arduino15\packages\Intel\hardware\arc32\1.0.4\variants\arduino_101" -Wl,--whole-archive "-larc32drv_arduino101" -Wl,--no-whole-archive -Wl,--start-group "-larc32drv_arduino101" -lc -lm -lgcc " > %temp1%

type %temp1% %objs% > %relinker%
@echo on
call %relinker%
@echo off

rem ---------------------
rem tAZuXg*.lstt@Cɏo
rem ---------------------
echo;
echo [AZuEXgt@C𐶐]
echo;
echo "%dir_gcc_bin%\%objdump% -hdSC  %f_elf% > "ARC-%f_list%"" 
      %dir_gcc_bin%\%objdump% -hdSC  %f_elf% > "ARC-%f_list%" 

echo;
echo [TCY]
%UserProfile%\AppData\Local\Arduino15\packages\Intel\tools\arc-elf32\1.6.4+1.0/bin/%size% build\%sketch_name%.ino.elf 
echo;
echo [I]

rem ---------------------
rem GfB^*.lstt@CI[v
rem start %f_list%
rem ---------------------

rem ꎞt@C폜
del  %objs% %ferr% %temp1% %relinker%

pause
goto :EOF

rem ---------------------
rem "t@C"擾(tH_Ɗgq폜)
rem ---------------------
:getScketchName
set sketch_name=%~n1
exit /b


